// version 2

#ifndef MESSAGE_ROUTER_HPP
#define MESSAGE_ROUTER_HPP

#include "BitStream.hpp"
#include "FastDelegate.h"

typedef fastdelegate::FastDelegate<void (BitStream &m)> MessageHandler;

class MessageRouter
{
	MessageHandler handlers[256];

public:
	void Set(u8 opcode, const MessageHandler &handler);
	void Clear(u8 opcode);

	void Invoke(u8 opcode, BitStream &msg);
};

#endif // include guard
