// version 2

#ifndef MUTEX_HPP
#define MUTEX_HPP

#if defined(_WIN32)
# define WIN32_LEAN_AND_MEAN
# include <windows.h>
#endif


class Mutex
{
	CRITICAL_SECTION cs;

public:
	Mutex();
	~Mutex();

	void Enter();
	void Leave();
};


class AutoMutex
{
	Mutex *mutex;

public:
	AutoMutex(Mutex &mutex);
	~AutoMutex();

	void Release();
};

#endif // include guard
